// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:msg/LoadCarrierModel.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/msg/load_carrier_model.h"


#ifndef RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER_MODEL__STRUCT_H_
#define RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER_MODEL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'id'
// Member 'type'
// Member 'pose_type'
#include "rosidl_runtime_c/string.h"
// Member 'outer_dimensions'
// Member 'inner_dimensions'
#include "rc_reason_msgs/msg/detail/box__struct.h"
// Member 'rim_thickness'
// Member 'rim_ledge'
#include "rc_reason_msgs/msg/detail/rectangle__struct.h"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__struct.h"

/// Struct defined in msg/LoadCarrierModel in the package rc_reason_msgs.
/**
  * This represents a load carrier by its geometry and its pose
 */
typedef struct rc_reason_msgs__msg__LoadCarrierModel
{
  rosidl_runtime_c__String id;
  /// Optional. The load carrier rim model. The only supported value is STANDARD
  rosidl_runtime_c__String type;
  /// Required
  rc_reason_msgs__msg__Box outer_dimensions;
  /// Required
  rc_reason_msgs__msg__Box inner_dimensions;
  /// Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
  rc_reason_msgs__msg__Rectangle rim_thickness;
  /// Optional. Height of the rim step for rims with an L-profile.
  double rim_step_height;
  /// Optional. Length of the rim ledge in x and y direction. This requires rim_thickness to be set.
  rc_reason_msgs__msg__Rectangle rim_ledge;
  /// When setting a load carrier, this is the prior if frame_id is not empty (should be 'camera' or 'external')
  geometry_msgs__msg__PoseStamped pose;
  /// Optional. Indicates how to interpret the load carrier pose
  /// If not set and pose is zero, it's equivalent to NO_POSE
  /// If not set and any value in pose is not zero, it's equivalent to ORIENTATION_PRIOR
  /// Valid values are:
  /// NO_POSE
  /// EXACT_POSE
  /// ORIENTATION_PRIOR
  rosidl_runtime_c__String pose_type;
} rc_reason_msgs__msg__LoadCarrierModel;

// Struct for a sequence of rc_reason_msgs__msg__LoadCarrierModel.
typedef struct rc_reason_msgs__msg__LoadCarrierModel__Sequence
{
  rc_reason_msgs__msg__LoadCarrierModel * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__msg__LoadCarrierModel__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER_MODEL__STRUCT_H_
